from PyQt4 import QtCore, QtGui

from Database import Database

import shutil
import os.path
from datetime import datetime
import sys
import os.path
from Action import Action
from Link import Link
from Sentence import Sentence
from Property import Property
from threading import Thread
from ProgressDialog import ProgressDialog

class exportThread(Thread):
    
    def __init__(self,activeDatabaseFilename,destinationDatabaseFilename,dialogWindow,doneFunction): 
        Thread.__init__(self)
        self.activeDatabaseFilename = activeDatabaseFilename
        self.destinationDatabaseFilename = destinationDatabaseFilename
        
        
        self.dialogWindow = dialogWindow
        self.doneFunction = doneFunction
        
    def run(self):
        if not self.activeDatabaseFilename == None and len(self.activeDatabaseFilename) > 0 and os.path.isfile(self.activeDatabaseFilename):
            if not self.destinationDatabaseFilename == None and len(self.destinationDatabaseFilename) > 0:
                self.dialogWindow.showMessage("Preparing export")
                adb = Database()
                ddb = Database()
                adb.openDatabase(self.activeDatabaseFilename)
                
                if not os.path.isfile(self.destinationDatabaseFilename):
                    ddb.createNewDatabase(self.destinationDatabaseFilename)
                else:
                    ddb.openDatabase(self.destinationDatabaseFilename)
                
                self.dialogWindow.showMessage("Exporting actions")
                actionList = adb.getAllActions()
                self.dialogWindow.setRange(0,len(actionList))
                counter = 0
                for action in actionList:
                    ddb.addNewAction(action.getAction())
                    counter += 1
                    self.dialogWindow.setValue(counter)
                
                self.dialogWindow.showMessage("Exporting properties")
                propertyList = adb.getAllPropertiesTuple(False)
                self.dialogWindow.setRange(0,len(propertyList))
                counter = 0
                for property in propertyList:
                    ddb.addNewProperty(property[1], property[2])
                    counter += 1
                    self.dialogWindow.setValue(counter)
                                
                self.dialogWindow.showMessage("Export completed")
                adb.closeDatabase()
                ddb.closeDatabase()
                
                
                self.doneFunction()
                
            else:
                self.dialogWindow.showMessage("Failed to save: "+str(self.destinationDatabaseFilename))
        else:
            self.dialogWindow.showMessage("Failed to open: "+str(self.activeDatabaseFilename))

class ExportTemplate(ProgressDialog):
    
    def __init__(self,parent,activeDatabaseFilename,destinationDatabaseFilename):
        ProgressDialog.__init__(self,parent,"Exporting template","Destination Database:",destinationDatabaseFilename,"Source Database:",activeDatabaseFilename,"Exporting..")
        self.activeDatabaseFilename = activeDatabaseFilename
        self.destinationDatabaseFilename = destinationDatabaseFilename
        thread = exportThread(self.activeDatabaseFilename,self.destinationDatabaseFilename,self,self.exportDone)
        
        thread.start()
                
        
    def exportDone(self):       
        
        self.done(0)