from PyQt4 import QtCore, QtGui

from Database import Database

import shutil
import os.path
from datetime import datetime
import sys
import os.path
from Action import Action
from Link import Link
from Sentence import Sentence
from Property import Property
from threading import Thread
from ProgressDialog import ProgressDialog


class importThread(Thread):
    
    def __init__(self,activeDatabaseFilename,sourceDatabaseFilename,dialogWindow,doneFunction): 
        Thread.__init__(self)
        self.activeDatabaseFilename = activeDatabaseFilename
        self.sourceDatabaseFilename = sourceDatabaseFilename
        
        
        self.dialogWindow = dialogWindow
        self.doneFunction = doneFunction
        
    def run(self):
        if not self.activeDatabaseFilename == None and len(self.activeDatabaseFilename) > 0 and os.path.isfile(self.activeDatabaseFilename):
            if not self.sourceDatabaseFilename == None and len(self.sourceDatabaseFilename) > 0 and os.path.isfile(self.sourceDatabaseFilename):
                self.dialogWindow.showMessage("Preparing import")
                adb = Database()
                sdb = Database()
                adb.openDatabase(self.activeDatabaseFilename)
                sdb.openDatabase(self.sourceDatabaseFilename)
                
                self.dialogWindow.showMessage("Importing actions")
                actionList = sdb.getAllActions()
                actionList = adb.getAllActions()
                self.dialogWindow.setRange(0,len(actionList))
                counter  = 0
                for action in actionList:
                    adb.addNewAction(action.getAction())
                    counter += 1
                    self.dialogWindow.setValue(counter)
                
                self.dialogWindow.showMessage("Importing properties")
                propertyList = sdb.getAllPropertiesTuple(False)
                self.dialogWindow.setRange(0,len(propertyList))
                counter = 0
                for property in propertyList:
                    adb.addNewProperty(property[1], property[2])
                    counter += 1
                    self.dialogWindow.setValue(counter)
                                
                self.dialogWindow.showMessage("Import completed")
                adb.closeDatabase()
                sdb.closeDatabase()
                
                
                self.doneFunction()
                
            else:
                self.dialogWindow.showMessage("Failed to open: "+str(self.sourceDatabaseFilename))
        else:
            self.dialogWindow.showMessage("Failed to open: "+str(self.activeDatabaseFilename))

class ImportTemplate(ProgressDialog):
    
    def __init__(self,parent,activeDatabaseFilename,sourceDatabaseFilename):
        ProgressDialog.__init__(self,parent,"Merging databases","Source Database:",sourceDatabaseFilename,"Destination Database:",activeDatabaseFilename,"Merging..")
        self.activeDatabaseFilename = activeDatabaseFilename
        self.sourceDatabaseFilename = sourceDatabaseFilename
        
        thread = importThread(self.activeDatabaseFilename,self.sourceDatabaseFilename,self,self.importDone)
        
        thread.start() 
               
        
    def importDone(self):       
        
        self.done(0)